loci.formats.in

## Class PrairieMetadata.Frame

- java.lang.Object
- - loci.formats.in.PrairieMetadata.Frame

- Enclosing class:
    PrairieMetadata

      public class PrairieMetadata.Frame
      extends java.lang.Object

  A Prairie `<Frame>`, beneath a `<Sequence>`.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private java.lang.Double` | `absoluteTime` `absoluteTime` attribute of this `<Frame>`.
    `private java.util.HashMap<java.lang.Integer,PrairieMetadata.PFile>` | `files` `<File>` elements beneath this `<Frame>`, keyed on each file's `channel`.
    `private PrairieMetadata.PFile` | `firstFile` The first actual `<File>` element for this `<Frame>`.
    `private PrairieMetadata.ValueTable` | `frameValues` Table of key/value pairs for this `<Frame>`.
    `private java.lang.Integer` | `index` `index` of this `<Frame>`.
    `private java.lang.Double` | `relativeTime` `relativeTime` attribute of this `<Frame>`.
    `private PrairieMetadata.Sequence` | `sequence` The `<Sequence>` containing this `<Frame>`.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Frame(PrairieMetadata.Sequence sequence, org.w3c.dom.Element frameElement)` Creates a new frame by parsing the given `<Frame>` element.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `double` | `getAbsoluteTime()` Gets the `absoluteTime` associated with this `Frame`.
    `PrairieMetadata.PFile` | `getFile(int channel)` Gets the `File` with the given `channel`.
    `PrairieMetadata.PFile` | `getFirstFile()` Gets the first `File` of the `Sequence`.
    `java.lang.Double` | `getGain(int c)` Gets the `c`th gain for this `Frame`.
    `java.lang.String` | `getImagingDevice()` Gets the imaging device associated with this `Frame`.
    `java.lang.String` | `getImmersion()` Extracts the immersion from the objective lens string.
    `int` | `getIndex()` Gets the `index` associated with this `Frame`.
    `java.lang.Integer` | `getLinesPerFrame()` Gets the lines per frame for this `Frame`.
    `java.lang.Double` | `getMagnification()` Extracts the magnification from the objective lens string.
    `java.lang.Double` | `getMicronsPerPixelX()` Gets the microns per pixel along X for this `Frame`.
    `java.lang.Double` | `getMicronsPerPixelY()` Gets the microns per pixel along Y for this `Frame`.
    `java.lang.String` | `getObjectiveLens()` Gets the objective lens string for this `Frame`.
    `java.lang.Double` | `getObjectiveLensNA()` Gets the numerical aperture of the lens for this `Frame`.
    `java.lang.String` | `getObjectiveManufacturer()` Extracts the objective manufacturer from the objective lens string.
    `java.lang.Double` | `getOffset(int c)` Gets the `c`th offset for this `Frame`.
    `java.lang.Double` | `getOpticalZoom()` Gets the optical zoom associated with this `Frame`.
    `java.lang.Integer` | `getPixelsPerLine()` Gets the pixels per line for this `Frame`.
    `ome.units.quantity.Length` | `getPositionX()` Gets the X stage position associated with this `Frame`.
    `ome.units.quantity.Length` | `getPositionY()` Gets the Y stage position associated with this `Frame`.
    `ome.units.quantity.Length` | `getPositionZ()` Gets the Z stage position associated with this `Frame`.
    `double` | `getRelativeTime()` Gets the `relativeTime` associated with this `Frame`.
    `PrairieMetadata.Sequence` | `getSequence()` Gets the `<Sequence>` containing this `<Frame>`.
    `PrairieMetadata.Value` | `getValue(java.lang.String key)` Gets the `value` of the given `key`, beneath this `Frame`, inferring the value from the parent `<Sequence>` or grandparent `<PVScan>` section as needed.
    `PrairieMetadata.ValueTable` | `getValues()` Gets the table of `Frame` key/value pairs.
    `void` | `parse(org.w3c.dom.Element frameElement)` Parses metadata from the given `Frame` element.
    `private ome.units.quantity.Length` | `toLength(java.lang.Double position, boolean isInvert)` Convert a position number to a length in the microscope reference frame.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### sequence

          private PrairieMetadata.Sequence sequence

      The `<Sequence>` containing this `<Frame>`.

    - #### files

          private final java.util.HashMap<java.lang.Integer,PrairieMetadata.PFile> files

      `<File>` elements beneath this `<Frame>`, keyed on each file's `channel`.

    - #### frameValues

          private final PrairieMetadata.ValueTable frameValues

      Table of key/value pairs for this `<Frame>`.

    - #### firstFile

          private PrairieMetadata.PFile firstFile

      The first actual `<File>` element for this `<Frame>`.

    - #### relativeTime

          private java.lang.Double relativeTime

      `relativeTime` attribute of this `<Frame>`.

    - #### absoluteTime

          private java.lang.Double absoluteTime

      `absoluteTime` attribute of this `<Frame>`.

    - #### index

          private java.lang.Integer index

      `index` of this `<Frame>`.

  - ### Constructor Detail

    - #### Frame

          public Frame(PrairieMetadata.Sequence sequence,
                       org.w3c.dom.Element frameElement)

      Creates a new frame by parsing the given `<Frame>` element.

  - ### Method Detail

    - #### getSequence

          public PrairieMetadata.Sequence getSequence()

      Gets the `<Sequence>` containing this `<Frame>`.

    - #### parse

          public void parse(org.w3c.dom.Element frameElement)

      Parses metadata from the given `Frame` element.

    - #### getRelativeTime

          public double getRelativeTime()

      Gets the `relativeTime` associated with this `Frame`.

    - #### getAbsoluteTime

          public double getAbsoluteTime()

      Gets the `absoluteTime` associated with this `Frame`.

    - #### getIndex

          public int getIndex()

      Gets the `index` associated with this `Frame`.

    - #### getFirstFile

          public PrairieMetadata.PFile getFirstFile()

      Gets the first `File` of the `Sequence`.

    - #### getFile

          public PrairieMetadata.PFile getFile(int channel)

      Gets the `File` with the given `channel`.

    - #### getObjectiveLens

          public java.lang.String getObjectiveLens()

      Gets the objective lens string for this `Frame`.

    - #### getObjectiveManufacturer

          public java.lang.String getObjectiveManufacturer()

      Extracts the objective manufacturer from the objective lens string.

    - #### getMagnification

          public java.lang.Double getMagnification()

      Extracts the magnification from the objective lens string.

    - #### getImmersion

          public java.lang.String getImmersion()

      Extracts the immersion from the objective lens string.

    - #### getObjectiveLensNA

          public java.lang.Double getObjectiveLensNA()

      Gets the numerical aperture of the lens for this `Frame`.

    - #### getPixelsPerLine

          public java.lang.Integer getPixelsPerLine()

      Gets the pixels per line for this `Frame`.

    - #### getLinesPerFrame

          public java.lang.Integer getLinesPerFrame()

      Gets the lines per frame for this `Frame`.

    - #### toLength

          private ome.units.quantity.Length toLength(java.lang.Double position,
                                                     boolean isInvert)

      Convert a position number to a length in the microscope reference frame.
      Parameters:
        `position` - a position number, may be `null`
        `isInvert` - if the number's sign should be flipped
      Returns:
        a length corresponding to the number, may be `null`

    - #### getPositionX

          public ome.units.quantity.Length getPositionX()

      Gets the X stage position associated with this `Frame`.

    - #### getPositionY

          public ome.units.quantity.Length getPositionY()

      Gets the Y stage position associated with this `Frame`.

    - #### getPositionZ

          public ome.units.quantity.Length getPositionZ()

      Gets the Z stage position associated with this `Frame`.

    - #### getOpticalZoom

          public java.lang.Double getOpticalZoom()

      Gets the optical zoom associated with this `Frame`.

    - #### getMicronsPerPixelX

          public java.lang.Double getMicronsPerPixelX()

      Gets the microns per pixel along X for this `Frame`.

    - #### getMicronsPerPixelY

          public java.lang.Double getMicronsPerPixelY()

      Gets the microns per pixel along Y for this `Frame`.

    - #### getOffset

          public java.lang.Double getOffset(int c)

      Gets the `c`th offset for this `Frame`.
      Parameters:
        `c` - The 0-based(!) channel index for which to obtain the offset.

    - #### getGain

          public java.lang.Double getGain(int c)

      Gets the `c`th gain for this `Frame`.
      Parameters:
        `c` - The 0-based(!) channel index for which to obtain the gain.

    - #### getImagingDevice

          public java.lang.String getImagingDevice()

      Gets the imaging device associated with this `Frame`.

    - #### getValue

          public PrairieMetadata.Value getValue(java.lang.String key)

      Gets the `value` of the given `key`, beneath this `Frame`, inferring the value from the parent `<Sequence>` or grandparent `<PVScan>` section as needed.

    - #### getValues

          public PrairieMetadata.ValueTable getValues()

      Gets the table of `Frame` key/value pairs.

Copyright © 2026 Open Microscopy Environment